\name{CatCall}
\alias{CatCall}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Visual Analysis of Period and Phase
%%  ~~function to do ... ~~
}
\description{ Perform one or more analyses to gain insight into periods and/or phase in a dataset:  Actogram, Smoothing, Autocorrelation or Crosscorrelation.
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
CatCall(startX, endX, lum = 4, export = F, sizePts = 2, binPts = 5, Span = 0, Increment = 0, k = 6, yLab = "Activity Level (au)", modulo = 1440, Rverbose = 0, RmaxGap = 400, Skip = 0, nFiles = 2, Smoothing = F, Actogram = F, AutoCorr = F, CrossCorr = F, Console = F, Graphics="pdf", Darkness1 = 1, Darkness2 = 0, LagPcnt = 0.33)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{startX, endX}{The range of columns, first and last, to analyze, in your data file.  Each function in Table 2 will cycle through all columns in this range, graphing the result for each.  In addition, analysis is done on the average of all columns.  Note that interpolation is always done to fill in missing data points.
%%     ~~Describe \code{startX} here~~
}

  \item{lum}{The column number containing luminance values.  Luminance values are used to determine where the light level drops sharply, and this point is used as the starting point for analysis.  Data points prior to this row (LumStart) are not used.
%%     ~~Describe \code{lum} here~~
}
  \item{export}{Boolean.  If True, a data file is saved of the data after filling in missing values and binning (per parameters). When True, each function (except Actogram) exports function results to separate comma delimited text files.
%%     ~~Describe \code{export} here~~
}
  \item{sizePts, binPts}{ sizePts is the number of minutes between samples.  binPts is the number of samples to aggregate into one bin. Binning is very flexible since it can be so important.  sizePts * binPts = number of minutes in each bin.   Only full bins are used for analysis, so there could be a few data points at the end of the data (after binEnd) that are not used.
%%     ~~Describe \code{sizePts} here~~
}
  \item{Span, Increment}{These two parameters are used together to specify a progressive analysis.  The span is the length of data to analyze, and the increment is how far to move ahead in the data to begin the next span.  (Span will need to be large enough not to trigger the error messages in the functions, which require more than 3 days for each analysis.) The entire data set will be analyzed (from LumStart to binEnd).   A progressive analysis, as indicated by Table 2, is performed by the Auto-Correlation, Cross-Correlation and Multitaper/Periodogram analyses.  The Actogram and Smoothing functions are performed on the full dataset length, for each column, as normal.  There is no benefit to viewing these graphs in subsections.
%%     ~~Describe \code{Span} here~~
}
  \item{k}{Only the Smoothing function uses this parameter.  It is a count of the number of data points on each side of a point to include in the moving average.  Each moving average is calculated using 2k data points.
%%     ~~Describe \code{k} here~~
}
  \item{yLab}{Label for the Y axis on Smoothing and Actogram functions.  Default-"Activity Level"
%%     ~~Describe \code{yLab} here~~
}
  \item{modulo}{Only the Actogram function uses this parameter.   It specifies the width in minutes to be used for displaying the Actogram.  Default is 1440 min, or 1 day.  
%%     ~~Describe \code{modulo} here~~
}
  \item{Rverbose}{for debug and can take on values of -1, 0,1 or 2.  0 turns off debug information.  1 or 2 add increasing amounts of debug information. -1 minimizes information displayed on graphs.
%%     ~~Describe \code{Rverbose} here~~
}
  \item{RmaxGap}{ specifies the maximum allowable number of missing data points in any one block.   An error will be returned if gaps larger than this are found in either data file.
%%     ~~Describe \code{RmaxGap} here~~
}
  \item{Skip}{ is a parameter to the R read.table function.  It is needed if you have multiple lines of header – the first row will be read as the header (unless you set header=F) and skip indicates how many rows to skip before reading data.  
%%     ~~Describe \code{Skip} here~~
}
  \item{nFiles}{ can be set to 1 or 2.  Normally you will read in 2 files, the first containing baseline data and the second containing experimental data, but it is also possible to specify only 1 file, in which case the Cross-Correlation function is not performed.
%%     ~~Describe \code{nFiles} here~~
}
  \item{Smoothing}{TRUE will cause this function to run, thus you select only the functions you need for any purpose.
%%     ~~Describe \code{Smoothing} here~~
}
  \item{Actogram}{TRUE will cause this function to run, thus you select only the functions you need for any purpose.
%%     ~~Describe \code{Actogram} here~~
}
  \item{AutoCorr}{TRUE will cause this function to run, thus you select only the functions you need for any purpose.
%%     ~~Describe \code{AutoCorr} here~~
}
  \item{CrossCorr}{TRUE will cause this function to run, thus you select only the functions you need for any purpose.
%%     ~~Describe \code{CrossCorr} here~~
}
  \item{Console}{ Default is F.  When Console=T output will be redirected to the RStudio Console, instead of an output file.
%%     ~~Describe \code{Console} here~~
}
  \item{Graphics}{ Results of CatCall are sent to a files when Console=F.  Default file output type is "pdf".   Possible values: "jpg, pdf, tif, png.   TIFF and PNG are higher resolution than jpeg and pdf.

  Plots in PNG and JPEG format can easily be converted to many other bitmap formats, and both can be displayed in modern web browsers. The PNG format is lossless and is best for line diagrams and blocks of colour. The JPEG format is lossy, but may be useful for image plots, for example. It is most often used in html web pages.  TIFF is a meta-format: the default format written by tiff is lossless and stores RGB (and alpha where appropriate) values uncompressed—such files are widely accepted, which is their main virtue over PNG.
%%     ~~Describe \code{Console} here~~
}
  \item{Darkness1, Darkness2}{This refers to the illumination column.  CAT analysis and graphing begins at darkness onset, as indicated by the lumninance column.  Normally, darkness is indicated by a very small number (<10) and light is a large number (>=10).  If this is needed to be reversed, changing the Darkness 1 or Darkness2 defaults will correct the interpretation of the lumninance column for file1 or file2, respectively.  Darknessx=0 means that darkness is a small number (<10).
%%     ~~Describe \code{Darkness1} here~~
}
  \item{LagPcnt}{  Specifies the percent of the data set to use in the calculation for Autocorrelation and Crosscorrelation.
%%     ~~Describe \code{LagPcnt} here~~
}
}
\section{Input Data:}{  
Input data is assumed to be equidistant, discrete, except for the luminance column, and the adjacent column to the left of lumninance (which may be temperature, but is not currently processed in CAT).  (Although CAT can be adapted easily to accept a parameter that will allow continuous data.)  An error will be reported if less than three days of data is provided in a file.  All columns are expected to be numeric.  

Data File format:  Tab delimited (.txt) file with the following columns:  

Date Time V0 luminance V1  V2  V3  V4  ...

A single data file with many data columns can be specified for analysis, in which case the Cross-Correlation function is skipped; or 2 data sets can be analyzed.  In all cases, interpolation is done to fill in missing data points; and then analysis is done on each specified data column in a file, as well as on the average of all columns individually analyzed.  When 2 data files are specified, the Cross-Correlation compares the phase register between the two sets.
}
\section{Output Data:}{  
Sample graphics output file:  See Output section on the web site for a sample of a full output file.  All graphs have the input data filename to clearly identify the data file under analysis, and a timestamp to show the time of analysis.  Each graph also lists the column name being analyzed (or averaged),  and the starting and ending times of analysis, as they vary slightly from the full data set (Lum to binEnd).    
Possible values:  jpg, pdf, tif, png

Output Data files:  The input data is interpolated and binned.  This transformed data can be exported using the export parameter.  If export=T then each function (except Actogram) exports a file with the results of the function. 
%%  ~~ If necessary, more details than the description above ~~
}

\references{http://564394709114639785.weebly.com/running-cat.html
%% ~put references to the literature/web site here ~
}
\author{Cathy Lee Gierke, Germaine Cornelissen-Guillaume, John A Lindgren

Maintainer: \email{ <leegi001@umn.edu>}
}
%%  ~~who you are~~

%% ~Make other sections like Warning with \section{Warning }{....} ~

\examples{##This will open a window allowing you to browse to a test file:  
                   activity stress c57--stress copy2-part
## The Smoothing function will be run on columns 5 and 6 which hold activity data. 
## (Luminance data is column 4 by default.)
CatCall(5,6,Smoothing=T, nFiles=1)

## The AutoCorrelation function will be run on columns 5 and 6 which hold activity data. 
## Binned and interpolated data will be exported, as well as the correlation coefficients 
## resulting from the autocorrelation function.
## 4 output files will be created:  1 with binned input;  3 with correlation coefficients: Avg, col 5, and col 6.
CatCall(5,6,AutoCorr=T, nFiles=1, export=TRUE)

##This will open a window allowing you to browse to two test files, in this order:  
##                     activity stress c57--stress copy2-part
##                     good-6d-2m-part
## All functions will be run, creating one large output file.
CatCall(5,6,Smoothing=T, Actogram=T,AutoCorr=T,CrossCorr=T)

}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~ Actogram }
\keyword{ ~ Smoothing }
\keyword{ ~ Autocorrelation }
\keyword{ ~ Crosscorrelation }
\keyword{ ~ cosinor }
\keyword{ ~ chronomics }
